#ifndef PATH_CHECKER_H_INCLUDED_
#define PATH_CHECKER_H_INCLUDED_

#include <vector>
#include <string>
#include <libgen.h>

#include "boost/filesystem.hpp"

#include "rose.h"

namespace risc {

namespace traverser {

/**
  * \brief             This funciton checks if the defintion of the node is in
  *                    a file that is located in the given include path
  * \param  project    Head node of the project
  * \return            True, if the node is located in a file in the include
  *                    folder
  */
bool is_defined_in_included_library(SgProject* project, SgNode* node);

}; // end namespace traverser

}; // end namespace risc

#endif /* PATH_CHECKER_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
