#ifndef EVENT_OR_LIST_H_INCLUDED_
#define EVENT_OR_LIST_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "object.h"

namespace risc {

class EventOrList: public Object {

public:

  /**
   * \brief default constructor
   */
  explicit EventOrList(SgVariableDefinition *ast_node);

  /**
   * \brief Get function for the name of the ast type of the event
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  EventOrList(const EventOrList &e);
};

typedef std::vector<EventOrList*> EventOrListVector;
typedef std::vector<EventOrList*>::iterator EventOrListVectorIter;
typedef std::vector<EventOrList*>::const_iterator EventOrListVectorConstIter;

}; // end namespace risc

#endif /* EVENT_OR_LIST_H_INCLUDED_ */
