#ifndef HIERARCHICAL_CHANNEL_H_INCLUDED_
#define HIERARCHICAL_CHANNEL_H_INCLUDED_

#include <vector>

#include "rose.h"

#include "module.h"

namespace risc {

class HierarchicalChannel: public Module {

public:

  /**
   * \brief Default constructor
   */
  explicit HierarchicalChannel(SgClassDefinition *ast_node);

  void print_hierarchical_channel_definition();

  /**
   * \brief This variable counts how many instances of this given type exsist
   *        in the desgin
   */
  int instance_counter_;

private:
  /**
   * \brief Disabled copy constructor
   */
  HierarchicalChannel(const HierarchicalChannel &hcd);
};

typedef std::vector<HierarchicalChannel*>
            HierarchicalChannelVector;
typedef std::vector<HierarchicalChannel*>::iterator
            HierarchicalChannelVectorIter;
typedef std::vector<HierarchicalChannel*>::const_iterator
            HierarchicalChannelVectorConstIter;

}; // end of namespace risc

#endif /* HIERARCHICAL_CHANNEL_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
