#include "object.h"

risc::Object::Object(SgVariableDefinition *ast_node, Type type):
  Definition(ast_node, type),
  number_of_array_elements_(0)
{
  ast_type_pointer_ = ast_node->get_vardefn()->get_typeptr();
  if(isSgArrayType(ast_type_pointer_)) {
    ast_type_pointer_ = SageInterface::getArrayElementType(ast_type_pointer_);
  }
}

SgVariableDefinition*
risc::Object::get_ast_node()
{
  return isSgVariableDefinition(ast_node_);
}

std::string
risc::Object::get_name()
{
  if(is_array()) {

    // its just cosmetics but required one!
    std::string name = get_ast_node()->get_vardefn()->get_name().str();
    name += " [ ";

    // TODO
    // Unfortunately this cases sometimes a segmentation fault
    //    name += + StringUtility::numberToString(
    //                  SageInterface::getArrayElementCount(
    //                      isSgArrayType(get_ast_node()->get_type())));
    name += " ]";

    return name;
  } else {
    return get_ast_node()->get_vardefn()->get_name().str();
  }
}

bool
risc::Object::is_array()
{
  return isSgArrayType(get_ast_node()->get_type()) ? true : false;
}

bool
risc::Object::is_reference()
{
  return isSgReferenceType(get_ast_node()->get_type());
}

bool
risc::Object::is_pointer()
{
  return isSgPointerType(get_ast_node()->get_type());
}

SgVariableSymbol*
risc::Object::get_symbol()
{
  return isSgVariableSymbol(get_ast_node()->get_vardefn()->
             search_for_symbol_from_symbol_table());
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
