#include "systemc.h"

class PathInstanceMapperA: public sc_module {
public:

  SC_HAS_PROCESS(PathInstanceMapperA);

  int &reference_a_;

  void thread1_a()
  {
    wait(SC_ZERO_TIME);

    reference_a_ = 3;

    wait(SC_ZERO_TIME);
    reference_a_;
  }

  void thread2_a()
  {
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }

  PathInstanceMapperA(sc_module_name mn, int &reference):
    sc_module(mn),
    reference_a_(reference)
  {
    SC_THREAD(thread1_a);
    SC_THREAD(thread2_a);
  }

};

class PathInstanceMapperB: public sc_module {
public:

  SC_HAS_PROCESS(PathInstanceMapperB);

  int &reference_b_;

  void thread1_b()
  {
    reference_b_ = 3;
    wait(SC_ZERO_TIME);

    reference_b_;
    wait(SC_ZERO_TIME);
  }

  void thread2_b()
  {
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }

  PathInstanceMapperB(sc_module_name mn, int &reference):
    sc_module(mn),
    reference_b_(reference)
  {
    SC_THREAD(thread1_b);
    SC_THREAD(thread2_b);
  }
};

class PathInstanceMapperTop: public sc_module {
public:

  int top_reference_;
  PathInstanceMapperA module_a0;
  PathInstanceMapperB module_b0;
  PathInstanceMapperA module_a1;
  PathInstanceMapperB module_b1;

  PathInstanceMapperTop(sc_module_name mn):
    sc_module(mn),
    module_a0("module_a0", top_reference_),
    module_b0("module_b0", top_reference_),
    module_a1("module_a1", top_reference_),
    module_b1("module_b1", top_reference_)
  { }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  PathInstanceMapperTop mm("mm");

  sc_start();
  return 0;
}

#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
