#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design d(argc,argv);

  // iterating all modules in the design
  for(risc::ModuleVectorIter
      iter  = d.module_definitions_.begin();
      iter != d.module_definitions_.end(); iter++) {

    // print all sub modules in the individual module definitions
    //(*iter)->print_module_definition();

    if((*iter)->get_name() == "Module0") {

      (*iter)->print_module_definition();

      for(risc::InPortVectorIter
          inport_iter  = (*iter)->inports_.begin();
          inport_iter != (*iter)->inports_.end();
          inport_iter++) {

      }

      for(risc::InOutPortVectorIter
          inoutport_iter  = (*iter)->inoutports_.begin();
          inoutport_iter != (*iter)->inoutports_.end();
          inoutport_iter++) {

        std::list<risc::InstanceTree> mapped_channels
          = risc::get_mapped_channel_instances(*inoutport_iter);

        std::cout << (*inoutport_iter)->get_name()
                  << " ->"
                  << std::endl;

        for(std::list<risc::InstanceTree>::iterator
            iter  = mapped_channels.begin();
            iter != mapped_channels.end();
            iter++) {
          (*iter).print_instance_tree();
        }
      }

      for(risc::OutPortVectorIter
          outport_iter  = (*iter)->outports_.begin();
          outport_iter != (*iter)->outports_.end();
          outport_iter++) {

      }
    }

//    std::cout << std::endl;
  }

  std::cout << std::endl;
  std::cout << std::endl;
  risc::InstanceTree tree = d.get_root();

  std::list<risc::InstanceTree> ports;
  tree.get_all_ports(ports);

  std::cout << "All ports:" << std::endl;
  for(std::list<risc::InstanceTree>::iterator
      iter  = ports.begin();
      iter != ports.end();
      iter++) {

    (*iter).print_instance_tree();

    risc::InstanceTree mapped_channel = get_mapped_channel_instance(*iter);
    std::cout << " -> " << std::endl;
    mapped_channel.print_instance_tree();
    std::cout << std::endl;
    std::cout << std::endl;
  }

  std::cout << std::endl;
  tree.print_instance_tree();

  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
