#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design d(argc,argv);

  for(risc::InstanceVectorIter
      iter_module  = d.top_modules_.begin();
      iter_module != d.top_modules_.end();
      iter_module++) {

    std::cout << (*iter_module)->get_ast_type_name()
              << " "
              << (*iter_module)->get_name()
              << std::endl;

    risc::ModuleInstance *module = dynamic_cast<risc::ModuleInstance*>(*iter_module);

    // print primitive channels
    if(module->get_definition()->sub_prim_channel_.size() != 0) {
      std::cout << " Primitive Channels" << std::endl;

      for(risc::PrimitiveChannelInstanceVectorIter
          iter  = module->get_definition()->sub_prim_channel_.begin();
          iter != module->get_definition()->sub_prim_channel_.end();
          iter++) {

        std::cout << " " << (*iter)->get_ast_type_name()
                  << " " << (*iter)->get_name() << std::endl;
      }
    }
  }

  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
